<script lang="ts" setup>
import { ref, onMounted, onBeforeUnmount } from 'vue';

interface Data {
  header?: string;
  text?: string;
  config?: {
    type: string;
  };
  list?: {
    config?: {
      type: string;
    };
    items: [{ text: string }];
  };
}

const props = defineProps<{
  data: Data;
}>();

const currentText = ref('');
const currentItemIndex = ref(0);
const prefersReducedMotion = ref(false);
let observer: IntersectionObserver | null = null;
const isTyping = ref(false);
const listContainer = ref(null);

const initIntersectionObserver = () => {
  const options = {
    root: null,
    rootMargin: '0px',
    threshold: 0.1,
  };

  observer = new IntersectionObserver(handleIntersect, options);
  const target = listContainer.value;
  if (target) {
    observer.observe(target);
  }
};

const handleIntersect = (entries: IntersectionObserverEntry[]) => {
  entries.forEach((entry) => {
    if (entry.isIntersecting) {
      typeWriterEffect();
      observer?.disconnect();
    }
  });
};

const typeWriterEffect = async () => {
  isTyping.value = true;
  let text = props.data.text || '';
  if (props.data.list && props.data.list.items) {
    for (let i = 0; i < props.data.list.items.length; i++) {
      currentItemIndex.value = i;
      text = props.data.list.items[i].text;
      await animateText(text);
    }
  } else {
    await animateText(text);
  }
  isTyping.value = false;
};

const animateText = async (text: string) => {
  for (let j = 0; j <= text.length; j++) {
    currentText.value = text.slice(0, j);
    await new Promise((resolve) => setTimeout(resolve, 20));
  }
};

onMounted(() => {
  const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
  prefersReducedMotion.value = mediaQuery.matches;
  if (!prefersReducedMotion.value) {
    initIntersectionObserver();
  }
});

onBeforeUnmount(() => {
  if (observer) {
    observer.disconnect();
  }
});
</script>

<template>
  <article class="text-results">
    <SlpTypography v-if="data.header" variant="heading5-bold" tag="h3" class="slp-my-24">
      {{ data.header }}
    </SlpTypography>

    <div v-if="data.list" ref="listContainer" class="list">
      <ol v-if="data.list.config?.type === 'ordered'">
        <li v-for="(item, index) in data.list.items" :key="index">
          <span v-if="prefersReducedMotion || index < currentItemIndex">{{ item.text }}</span>
          <span v-else-if="index === currentItemIndex">{{ currentText }}</span>
        </li>
      </ol>
    </div>
    <div v-else class="text">
      <div v-html="$md.render(data.text)" />
    </div>
  </article>
</template>

<style lang="scss" scoped>
.text-results {
  min-height: 150px;

  .text,
  .list {
    font-family: 'GitLab Mono';
  }

  .list {
    font-size: 18px;

    ol {
      list-style: auto;
      padding-left: 2.1em;
    }

    li {
      margin-bottom: 16px;
    }
  }

  .text:deep(p) {
    margin-bottom: 16px;

    &:last-of-type {
      margin-bottom: 0;
    }
  }
}
</style>
